' The property editor's basic property page.
<ToolboxItem(False)> _
Public Class ScribbleControlEditorBasicsPage
    Inherits System.Windows.Forms.Design.ComponentEditorPage

    Private m_ScribbleControl As ScribbleControl

    Friend WithEvents lblLineWidth As System.Windows.Forms.Label
    Friend WithEvents lwlLineWidthEditorListBox As LineWidthListBox
    Friend WithEvents lblBackColor As System.Windows.Forms.Label
    Friend WithEvents picBackColor As System.Windows.Forms.PictureBox
    Friend WithEvents dlgBackColor As System.Windows.Forms.ColorDialog
    Friend WithEvents lblLineColor As System.Windows.Forms.Label
    Friend WithEvents cilColorIndexListBox As ColorIndexListBox

    ' Initialize the page.
    Public Sub New()
        Me.Size = New Size(400, 200)
        Me.Text = "Basics"
        Me.Icon = My.Resources.icoScribbleBasics

        Me.lblLineWidth = New System.Windows.Forms.Label
        Me.lblLineWidth.AutoSize = True
        Me.lblLineWidth.Location = New System.Drawing.Point(8, 8)
        Me.lblLineWidth.Name = "lblLineWidth"
        Me.lblLineWidth.Size = New System.Drawing.Size(61, 13)
        Me.lblLineWidth.TabIndex = 0
        Me.lblLineWidth.Text = "Line Width:"

        Me.lwlLineWidthEditorListBox = New LineWidthListBox(1, Nothing)
        Me.lwlLineWidthEditorListBox.Location = New System.Drawing.Point(112, 8)
        Me.lwlLineWidthEditorListBox.Name = "lwdLineWidthEditorDropdown"
        Me.lwlLineWidthEditorListBox.Size = New System.Drawing.Size(72, 134)
        Me.lwlLineWidthEditorListBox.TabIndex = 1

        Me.lblLineColor = New System.Windows.Forms.Label
        Me.lblLineColor.AutoSize = True
        Me.lblLineColor.Location = New System.Drawing.Point(208, 8)
        Me.lblLineColor.Name = "lblLineColor"
        Me.lblLineColor.Size = New System.Drawing.Size(61, 13)
        Me.lblLineColor.TabIndex = 0
        Me.lblLineColor.Text = "Line Color:"

        Me.cilColorIndexListBox = New ColorIndexListBox(ScribbleControl.LineColors.Black, Nothing)
        Me.cilColorIndexListBox.Location = New System.Drawing.Point(312, 8)
        Me.cilColorIndexListBox.Name = "cilColorIndexListBox"
        Me.cilColorIndexListBox.Size = New System.Drawing.Size(72, 134)
        Me.cilColorIndexListBox.TabIndex = 3

        Me.lblBackColor = New System.Windows.Forms.Label
        Me.lblBackColor.AutoSize = True
        Me.lblBackColor.Location = New System.Drawing.Point(8, 152)
        Me.lblBackColor.Name = "lblBackColor"
        Me.lblBackColor.Size = New System.Drawing.Size(95, 13)
        Me.lblBackColor.TabIndex = 0
        Me.lblBackColor.Text = "Background Color:"

        Me.picBackColor = New System.Windows.Forms.PictureBox
        Me.picBackColor.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picBackColor.Location = New System.Drawing.Point(112, 152)
        Me.picBackColor.Name = "picBackColor"
        Me.picBackColor.Size = New System.Drawing.Size(72, 20)
        Me.picBackColor.TabIndex = 2
        Me.picBackColor.TabStop = False

        Me.dlgBackColor = New System.Windows.Forms.ColorDialog

        Me.Controls.AddRange(New Control() { _
            lblLineWidth, lwlLineWidthEditorListBox, _
            lblBackColor, picBackColor, _
            lblLineColor, cilColorIndexListBox _
        })
    End Sub

    ' The LoadComponent method is raised when the ComponentEditorPage is displayed.
    Protected Overrides Sub LoadComponent()
        m_ScribbleControl = DirectCast(Me.Component, ScribbleControl)
        picBackColor.BackColor = m_ScribbleControl.BackColor
        lwlLineWidthEditorListBox.SelectedIndex = m_ScribbleControl.LineWidth - 1
        cilColorIndexListBox.SelectedIndex = CType(m_ScribbleControl.LineColor, Integer)
    End Sub

    ' Save the selected LineWidth and BackColor.
    Protected Overrides Sub SaveComponent()
        m_ScribbleControl.LineWidth = lwlLineWidthEditorListBox.SelectedIndex + 1
        m_ScribbleControl.BackColor = picBackColor.BackColor
        m_ScribbleControl.LineColor = CType(cilColorIndexListBox.SelectedIndex, ScribbleControl.LineColors)
    End Sub

    ' Let the user select a color from a ColorDialog.
    Private Sub picBackColor_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles picBackColor.Click
        If dlgBackColor.ShowDialog() = Windows.Forms.DialogResult.OK Then
            picBackColor.BackColor = dlgBackColor.Color

            ' Let the editor know that the user changed a property value.
            Me.SetDirty()
        End If
    End Sub

    ' Let the editor know that the user changed a property value.
    Private Sub lwlLineWidthEditorListBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles lwlLineWidthEditorListBox.SelectedIndexChanged
        Me.SetDirty()
    End Sub

    ' Let the editor know that the user changed a property value.
    Private Sub cilColorIndexListBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cilColorIndexListBox.SelectedIndexChanged
        Me.SetDirty()
    End Sub
End Class
